<Activity mc:Ignorable="sap sap2010" x:Class="Load_Opportunity_Data_To_Queue" xmlns="http://schemas.microsoft.com/netfx/2009/xaml/activities" xmlns:mc="http://schemas.openxmlformats.org/markup-compatibility/2006" xmlns:mva="clr-namespace:Microsoft.VisualBasic.Activities;assembly=System.Activities" xmlns:sap="http://schemas.microsoft.com/netfx/2009/xaml/activities/presentation" xmlns:sap2010="http://schemas.microsoft.com/netfx/2010/xaml/activities/presentation" xmlns:scg="clr-namespace:System.Collections.Generic;assembly=mscorlib" xmlns:sd="clr-namespace:System.Data;assembly=System.Data" xmlns:ui="http://schemas.uipath.com/workflow/activities" xmlns:x="http://schemas.microsoft.com/winfx/2006/xaml">
  <x:Members>
    <x:Property Name="in_SalesforceReportStartCell" Type="InArgument(x:String)" />
    <x:Property Name="in_SalesforceReportTempPath" Type="InArgument(x:String)" />
    <x:Property Name="in_SalesforceReportSheetName" Type="InArgument(x:String)" />
    <x:Property Name="in_QueueNameOpportunitiesToClose" Type="InArgument(x:String)" />
    <x:Property Name="in_OpportunitesIDTracker" Type="InArgument(x:String)" />
  </x:Members>
  <sap:VirtualizedContainerService.HintSize>1085,1660</sap:VirtualizedContainerService.HintSize>
  <sap2010:WorkflowViewState.IdRef>ActivityBuilder_1</sap2010:WorkflowViewState.IdRef>
  <TextExpression.NamespacesForImplementation>
    <scg:List x:TypeArguments="x:String" Capacity="29">
      <x:String>System.Activities</x:String>
      <x:String>System.Activities.Statements</x:String>
      <x:String>System</x:String>
      <x:String>System.Collections</x:String>
      <x:String>System.Collections.Generic</x:String>
      <x:String>System.Data</x:String>
      <x:String>System.IO</x:String>
      <x:String>UiPath.Core</x:String>
      <x:String>UiPath.Core.Activities</x:String>
      <x:String>System.Runtime.Serialization</x:String>
      <x:String>System.ComponentModel</x:String>
      <x:String>System.Xml.Serialization</x:String>
      <x:String>UiPath.Excel</x:String>
      <x:String>UiPath.Excel.Activities</x:String>
      <x:String>System.Reflection</x:String>
      <x:String>System.Runtime.InteropServices</x:String>
      <x:String>UiPath.Core.Activities.Orchestrator</x:String>
      <x:String>System.Collections.ObjectModel</x:String>
      <x:String>System.Activities.DynamicUpdate</x:String>
      <x:String>System.Activities.Expressions</x:String>
      <x:String>System.Diagnostics</x:String>
      <x:String>System.Drawing</x:String>
      <x:String>System.Linq</x:String>
      <x:String>System.Xml</x:String>
      <x:String>System.Xml.Linq</x:String>
      <x:String>System.Net.Mail</x:String>
      <x:String>Microsoft.VisualBasic</x:String>
      <x:String>UiPath.CSV</x:String>
      <x:String>UiPath.CSV.Activities</x:String>
    </scg:List>
  </TextExpression.NamespacesForImplementation>
  <TextExpression.ReferencesForImplementation>
    <scg:List x:TypeArguments="AssemblyReference" Capacity="29">
      <AssemblyReference>System.Activities</AssemblyReference>
      <AssemblyReference>Microsoft.VisualBasic</AssemblyReference>
      <AssemblyReference>mscorlib</AssemblyReference>
      <AssemblyReference>System.Data</AssemblyReference>
      <AssemblyReference>System.Data.DataSetExtensions</AssemblyReference>
      <AssemblyReference>System</AssemblyReference>
      <AssemblyReference>System.Drawing</AssemblyReference>
      <AssemblyReference>System.Core</AssemblyReference>
      <AssemblyReference>System.Xml</AssemblyReference>
      <AssemblyReference>System.Xml.Linq</AssemblyReference>
      <AssemblyReference>PresentationFramework</AssemblyReference>
      <AssemblyReference>WindowsBase</AssemblyReference>
      <AssemblyReference>PresentationCore</AssemblyReference>
      <AssemblyReference>System.Xaml</AssemblyReference>
      <AssemblyReference>UiPath.System.Activities</AssemblyReference>
      <AssemblyReference>UiPath.UiAutomation.Activities</AssemblyReference>
      <AssemblyReference>System.Runtime.Serialization</AssemblyReference>
      <AssemblyReference>System.ValueTuple</AssemblyReference>
      <AssemblyReference>UiPath.Cryptography</AssemblyReference>
      <AssemblyReference>UiPath.Excel</AssemblyReference>
      <AssemblyReference>UiPath.Mail</AssemblyReference>
      <AssemblyReference>System.Memory</AssemblyReference>
      <AssemblyReference>Microsoft.Bcl.AsyncInterfaces</AssemblyReference>
      <AssemblyReference>UiPath.OCR.Activities.Design</AssemblyReference>
      <AssemblyReference>UiPath.UIAutomationCore</AssemblyReference>
      <AssemblyReference>System.ServiceModel</AssemblyReference>
      <AssemblyReference>System.ComponentModel.Composition</AssemblyReference>
      <AssemblyReference>UiPath.Excel.Activities</AssemblyReference>
      <AssemblyReference>System.ServiceModel.Activities</AssemblyReference>
    </scg:List>
  </TextExpression.ReferencesForImplementation>
  <Sequence DisplayName="Load_Opportunity_Data_To_Queue" sap:VirtualizedContainerService.HintSize="656,1595" sap2010:WorkflowViewState.IdRef="Sequence_3">
    <Sequence.Variables>
      <Variable x:TypeArguments="sd:DataTable" Name="dt_opportunitiesProcessedByBot" />
      <Variable x:TypeArguments="sd:DataTable" Name="dt_salesforceOpportunities" />
      <Variable x:TypeArguments="sd:DataTable" Name="dt_opportunitiesToClose" />
    </Sequence.Variables>
    <sap:WorkflowViewStateService.ViewState>
      <scg:Dictionary x:TypeArguments="x:String, x:Object">
        <x:Boolean x:Key="IsExpanded">True</x:Boolean>
      </scg:Dictionary>
    </sap:WorkflowViewStateService.ViewState>
    <ui:ReadRange AddHeaders="True" DataTable="[dt_salesforceOpportunities]" DisplayName="Read Range" sap:VirtualizedContainerService.HintSize="614,87" sap2010:WorkflowViewState.IdRef="ReadRange_2" Range="[in_SalesforceReportStartCell]" SheetName="[in_SalesforceReportSheetName]" WorkbookPath="[in_SalesforceReportTempPath]" />
    <Sequence DisplayName="Iterate columns and remove all columns excepts &quot;Opportunity Unique ID&quot;" sap:VirtualizedContainerService.HintSize="614,954" sap2010:WorkflowViewState.IdRef="Sequence_1">
      <Sequence.Variables>
        <Variable x:TypeArguments="x:Int32" Name="columnsCount" />
        <Variable x:TypeArguments="x:Int32" Name="columnIndex" />
      </Sequence.Variables>
      <sap:WorkflowViewStateService.ViewState>
        <scg:Dictionary x:TypeArguments="x:String, x:Object">
          <x:Boolean x:Key="IsExpanded">True</x:Boolean>
        </scg:Dictionary>
      </sap:WorkflowViewStateService.ViewState>
      <Assign DisplayName="Assign columnsCount" sap:VirtualizedContainerService.HintSize="572,60" sap2010:WorkflowViewState.IdRef="Assign_1">
        <Assign.To>
          <OutArgument x:TypeArguments="x:Int32">[columnsCount]</OutArgument>
        </Assign.To>
        <Assign.Value>
          <InArgument x:TypeArguments="x:Int32">[dt_salesforceOpportunities.Columns.Count]</InArgument>
        </Assign.Value>
      </Assign>
      <Assign DisplayName="Assign startColumn" sap:VirtualizedContainerService.HintSize="572,60" sap2010:WorkflowViewState.IdRef="Assign_2">
        <Assign.To>
          <OutArgument x:TypeArguments="x:Int32">[columnIndex]</OutArgument>
        </Assign.To>
        <Assign.Value>
          <InArgument x:TypeArguments="x:Int32">0</InArgument>
        </Assign.Value>
      </Assign>
      <DoWhile DisplayName="Iterate columns and remove all columns excepts &quot;Opportunity Unique ID&quot;" sap:VirtualizedContainerService.HintSize="572,662" sap2010:WorkflowViewState.IdRef="DoWhile_1">
        <DoWhile.Condition>
          <mva:VisualBasicValue x:TypeArguments="x:Boolean" ExpressionText="columnIndex &lt;= columnsCount" sap2010:WorkflowViewState.IdRef="VisualBasicValue`1_1" />
        </DoWhile.Condition>
        <Sequence DisplayName="Remove all columns except Opportunity Unique ID" sap:VirtualizedContainerService.HintSize="526,500" sap2010:WorkflowViewState.IdRef="Sequence_2">
          <Sequence.Variables>
            <Variable x:TypeArguments="x:Int32" Name="lastColumn" />
          </Sequence.Variables>
          <sap:WorkflowViewStateService.ViewState>
            <scg:Dictionary x:TypeArguments="x:String, x:Object">
              <x:Boolean x:Key="IsExpanded">True</x:Boolean>
            </scg:Dictionary>
          </sap:WorkflowViewStateService.ViewState>
          <Assign DisplayName="Assign lastColumn" sap:VirtualizedContainerService.HintSize="484,60" sap2010:WorkflowViewState.IdRef="Assign_5">
            <Assign.To>
              <OutArgument x:TypeArguments="x:Int32">[lastColumn]</OutArgument>
            </Assign.To>
            <Assign.Value>
              <InArgument x:TypeArguments="x:Int32">[dt_salesforceOpportunities.Columns.Count -1]</InArgument>
            </Assign.Value>
          </Assign>
          <If Condition="[Not dt_salesforceOpportunities.Columns(lastColumn).ColumnName.Equals(&quot;Opportunity Unique ID&quot;)]" DisplayName="Remove all columns excepts &quot;Opportunity Unique ID&quot;" sap:VirtualizedContainerService.HintSize="484,208" sap2010:WorkflowViewState.IdRef="If_2">
            <If.Then>
              <ui:RemoveDataColumn Column="{x:Null}" ColumnName="{x:Null}" ColumnIndex="[lastColumn]" DataTable="[dt_salesforceOpportunities]" DisplayName="Remove Data Column" sap:VirtualizedContainerService.HintSize="200,22" sap2010:WorkflowViewState.IdRef="RemoveDataColumn_2" />
            </If.Then>
          </If>
          <Assign sap:VirtualizedContainerService.HintSize="484,60" sap2010:WorkflowViewState.IdRef="Assign_3">
            <Assign.To>
              <OutArgument x:TypeArguments="x:Int32">[columnIndex]</OutArgument>
            </Assign.To>
            <Assign.Value>
              <InArgument x:TypeArguments="x:Int32">[columnIndex + 1]</InArgument>
            </Assign.Value>
          </Assign>
        </Sequence>
      </DoWhile>
    </Sequence>
    <Assign DisplayName="Change name of column &quot;Opportunity Unique ID&quot; to &quot;Reference&quot;" sap:VirtualizedContainerService.HintSize="614,60" sap2010:WorkflowViewState.IdRef="Assign_4">
      <Assign.To>
        <OutArgument x:TypeArguments="x:String">[dt_salesforceOpportunities.Columns("Opportunity Unique ID").ColumnName]</OutArgument>
      </Assign.To>
      <Assign.Value>
        <InArgument x:TypeArguments="x:String">Reference</InArgument>
      </Assign.Value>
    </Assign>
    <ui:RemoveDataRow Row="{x:Null}" DataTable="[dt_salesforceOpportunities]" DisplayName="Remove Last row with Total summary" sap:VirtualizedContainerService.HintSize="614,22" sap2010:WorkflowViewState.IdRef="RemoveDataRow_1" RowIndex="[dt_salesforceOpportunities.Rows.Count -1]" />
    <ui:ReadCsvFile Encoding="{x:Null}" DataTable="[dt_opportunitiesProcessedByBot]" Delimitator="Comma" DisplayName="Read CSV - OpportunitesIDTracker to dt_processedOpportunities" FilePath="[in_OpportunitesIDTracker]" sap:VirtualizedContainerService.HintSize="614,59" sap2010:WorkflowViewState.IdRef="ReadCsvFile_1" />
    <ui:JoinDataTables DataTable1="[dt_salesforceOpportunities]" DataTable2="[dt_opportunitiesProcessedByBot]" DisplayName="From Salesforce report Extract only opportunities that have been proceesd by the bot " sap:VirtualizedContainerService.HintSize="614,59" sap2010:WorkflowViewState.IdRef="JoinDataTables_1" JoinType="Inner" OutputDataTable="[dt_opportunitiesToClose]">
      <ui:JoinDataTables.Arguments>
        <scg:List x:TypeArguments="ui:JoinOperationArgument" Capacity="4">
          <ui:JoinOperationArgument Operand="{x:Null}" BooleanOperator="And" Operator="EQ">
            <ui:JoinOperationArgument.Column1>
              <InArgument x:TypeArguments="x:String">["Reference"]</InArgument>
            </ui:JoinOperationArgument.Column1>
            <ui:JoinOperationArgument.Column2>
              <InArgument x:TypeArguments="x:String">["Opportunity Unique ID"]</InArgument>
            </ui:JoinOperationArgument.Column2>
          </ui:JoinOperationArgument>
        </scg:List>
      </ui:JoinDataTables.Arguments>
    </ui:JoinDataTables>
    <ui:BulkAddQueueItems TimeoutMS="{x:Null}" DisplayName="Bulk Add Queue Items" sap:VirtualizedContainerService.HintSize="614,22" sap2010:WorkflowViewState.IdRef="BulkAddQueueItems_2" QueueItemsDataTable="[dt_opportunitiesToClose]" QueueName="[in_QueueNameOpportunitiesToClose]" />
  </Sequence>
</Activity>